---------------------------------
-----------Frontkanone-----------
---------------------------------
---------------------------------
--------- @author Classtraktor - Harley ---------
-------- @date  28/06/10 --------
---------------------------------

Frontkanone = {};

function Frontkanone.prerequisitesPresent(specializations)
    return true;
end;

function Frontkanone:load(xmlFile)

local rotationNodePartRamie = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotatiokleinPartRamie#index"));
    if rotationNodePartRamie ~= nil then
        self.rotationkleinPartRamie = {};
        self.rotationkleinPartRamie.node = rotationNodePartRamie;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotatiokleinPartRamie#minRot"));
        self.rotationkleinPartRamie.minRot = {};
        self.rotationkleinPartRamie.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationkleinPartRamie.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationkleinPartRamie.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotatiokleinPartRamie#maxRot"));
        self.rotationkleinPartRamie.maxRot = {};
        self.rotationkleinPartRamie.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationkleinPartRamie.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationkleinPartRamie.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationkleinPartRamie.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotatiokleinPartRamie#rotTime"), 2)*1000;
        self.rotationkleinPartRamie.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotatiokleinPartRamie#touchRotLimit"), 10));
    end; 

local rotationNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotatioklein2#index"));
    if rotationNode2 ~= nil then
        self.rotationklein2 = {};
        self.rotationklein2.node = rotationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotatioklein2#minRot"));
        self.rotationklein2.minRot = {};
        self.rotationklein2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationklein2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationklein2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotatioklein2#maxRot"));
        self.rotationklein2.maxRot = {};
        self.rotationklein2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationklein2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationklein2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationklein2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotatioklein2#rotTime"), 2)*1000;
        self.rotationklein2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotatioklein2#touchRotLimit"), 10));
    end; 

local rotationNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotatioklein3#index"));
    if rotationNode3 ~= nil then
        self.rotationklein3 = {};
        self.rotationklein3.node = rotationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotatioklein3#minRot"));
        self.rotationklein3.minRot = {};
        self.rotationklein3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationklein3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationklein3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotatioklein3#maxRot"));
        self.rotationklein3.maxRot = {};
        self.rotationklein3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationklein3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationklein3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationklein3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotatioklein3#rotTime"), 2)*1000;
        self.rotationklein3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotatioklein3#touchRotLimit"), 10));
    end; 

	local rotationNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotatioklein4#index"));
    if rotationNode4 ~= nil then
        self.rotationklein4 = {};
        self.rotationklein4.node = rotationNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotatioklein4#minRot"));
        self.rotationklein4.minRot = {};
        self.rotationklein4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationklein4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationklein4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotatioklein4#maxRot"));
        self.rotationklein4.maxRot = {};
        self.rotationklein4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationklein4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationklein4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationklein4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotatioklein4#rotTime"), 2)*1000;
        self.rotationklein4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotatioklein4#touchRotLimit"), 10));
    end; 
	-- Start Index
	local translationNodeWspornik1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translatiokleinWspornik1#index"));
    if translationNodeWspornik1 ~= nil then
        self.translationkleinWspornik1 = {};
        self.translationkleinWspornik1.node = translationNodeWspornik1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translatiokleinWspornik1#minTrans"));
        self.translationkleinWspornik1.minTrans = {};
        self.translationkleinWspornik1.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationkleinWspornik1.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationkleinWspornik1.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translatiokleinWspornik1#maxTrans"));
        self.translationkleinWspornik1.maxTrans = {};
        self.translationkleinWspornik1.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationkleinWspornik1.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationkleinWspornik1.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationkleinWspornik1.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translatiokleinWspornik1#transTime"), 2)*1000;
        self.translationkleinWspornik1.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translatiokleinWspornik1#touchTransLimit"), 10);
    end; 

	-- width index
	local translationklein2Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translatioklein2#index"));
    if translationklein2Node ~= nil then
        self.translationklein2 = {};
        self.translationklein2.node = translationklein2Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translatioklein2#minTrans"));
        self.translationklein2.minTrans = {};
        self.translationklein2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationklein2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationklein2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translatioklein2#maxTrans"));
        self.translationklein2.maxTrans = {};
        self.translationklein2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationklein2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationklein2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationklein2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translatioklein2#transTime"), 2)*1000;
        self.translationklein2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translatioklein2#touchTransLimit"), 10);
    end;

	local translationklein3Node = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translatioklein3#index"));
    if translationklein3Node ~= nil then
        self.translationklein3 = {};
        self.translationklein3.node = translationklein3Node;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translatioklein3#minTrans"));
        self.translationklein3.minTrans = {};
        self.translationklein3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationklein3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationklein3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translatioklein3#maxTrans"));
        self.translationklein3.maxTrans = {};
        self.translationklein3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationklein3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationklein3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationklein3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translatioklein3#transTime"), 2)*1000;
        self.translationklein3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translatioklein3#touchTransLimit"), 10);
	
		
    end;
	
	self.keyB = false;
	self.primo = false;
end;

function Frontkanone:delete()
end;

function Frontkanone:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Frontkanone:keyEvent(unicode, sym, modifier, isDown)
	
	
	
	if sym == Input.KEY_j then
		self.rotationkleinMaxRamie = isDown;
		self.rotationklein4Max = isDown;

	end;
	if sym == Input.KEY_h then
		self.rotationkleinMinRamie = isDown;
		self.rotationklein4Min = isDown;
	end;
	
	-- Codice originale non scommentare
    if sym == Input.KEY_KP_8 then
		--self.translationMax = isDown;
		--self.translationklein2Max = isDown;
	end;
	-- Codice originale
	
	if sym == Input.KEY_z then
		self.translationMin = isDown;
		self.translationklein2Min = isDown;
	end;
    
	if sym == Input.KEY_y then
		self.rotationklein2Max = isDown;
		self.rotationklein3Max = isDown;
		self.translationklein3Max = isDown;
		
	end;
	if sym == Input.KEY_z then
		self.rotationklein2Min = isDown;
		self.rotationklein3Min = isDown;
		self.translationklein3Min = isDown;
	end;

	
	if isDown and sym == Input.KEY_y then
		self.translationMax = not self.translationMax;
		self.translationklein2Max = not self.translationklein2Max;
	end;
	
	--if sym == Input.KEY_b then
	--	print("KEY_b");
	--	if self.keyB then
	--		self.translationMin = true;
	--		self.translationklein2Min = true;
	--		self.primo = true;
	--	else
	--		self.keyB = true;
	--		self.translationMax = true;
	--		self.translationklein2Max = true;
	--		self.primo = true;
	--	end;
	--end;
	
end;

function Frontkanone:update(dt)
	
	if self.translationkleinWspornik1 ~= nil then 
		local x, y, z = getTranslation(self.translationkleinWspornik1.node);
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationkleinWspornik1.maxTrans, self.translationkleinWspornik1.minTrans, 3, self.translationkleinWspornik1.transTime, dt, not self.translationMax); 
		setTranslation(self.translationkleinWspornik1.node, unpack(newTrans)); 
	end;
	
	if self.translationklein2 ~= nil then
		local x, y, z = getTranslation(self.translationklein2.node);
		local trans = {x,y,z};
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationklein2.maxTrans, self.translationklein2.minTrans, 3, self.translationklein2.transTime, dt, not self.translationklein2Max);
		setTranslation(self.translationklein2.node, unpack(newTrans));
	end;
	
	local doRotate = self.rotationkleinMaxRamie or self.rotationkleinMinRamie
	if self.rotationkleinPartRamie ~= nil and doRotate then
		local x, y, z = getRotation(self.rotationkleinPartRamie.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationkleinPartRamie.maxRot, self.rotationkleinPartRamie.minRot, 3, self.rotationkleinPartRamie.rotTime, dt, not self.rotationkleinMaxRamie);
		setRotation(self.rotationkleinPartRamie.node, unpack(newRot));
	end;

	local doRotate = self.rotationklein2Max or self.rotationklein2Min
	if self.rotationklein2 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotationklein2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationklein2.maxRot, self.rotationklein2.minRot, 3, self.rotationklein2.rotTime, dt, not self.rotationklein2Max);
		setRotation(self.rotationklein2.node, unpack(newRot));
	end;

	local doRotate = self.rotationklein3Max or self.rotationklein3Min
	if self.rotationklein3 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotationklein3.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationklein3.maxRot, self.rotationklein3.minRot, 3, self.rotationklein3.rotTime, dt, not self.rotationklein3Max);
		setRotation(self.rotationklein3.node, unpack(newRot));
	end;

	local doRotate = self.rotationklein4Max or self.rotationklein4Min
	if self.rotationklein4 ~= nil and doRotate then
		local x, y, z = getRotation(self.rotationklein4.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationklein4.maxRot, self.rotationklein4.minRot, 3, self.rotationklein4.rotTime, dt, not self.rotationklein4Max);
		setRotation(self.rotationklein4.node, unpack(newRot));
	end;
	
	-- Codice originale non scommentare
	--local doTranslate = self.translationMax or self.translationMin
	--if self.translationkleinWspornik1 ~= nil and doTranslate then 
	--	local x, y, z = getTranslation(self.translationkleinWspornik1.node);
	--	print("translat1 x, y, z:"..x..","..y..","..z);
	--	local trans = {x,y,z}; 
	--	local newTrans = Utils.getMovedLimitedValues(trans, self.translationkleinWspornik1.maxTrans, self.translationkleinWspornik1.minTrans, 3, self.translationkleinWspornik1.transTime, dt, not self.translationMax); 
	--	setTranslation(self.translationkleinWspornik1.node, unpack(newTrans)); 
	--end;
	--local doTranslate = self.translationMax or self.translationMin
	--if self.translationklein2 ~= nil and doTranslate then 
	--	local x, y, z = getTranslation(self.translationklein2.node); 
	--	local trans = {x,y,z}; 
	--	local newTrans = Utils.getMovedLimitedValues(trans, self.translationklein2.maxTrans, self.translationklein2.minTrans, 3, self.translationklein2.transTime, dt, not self.translationMax); 
	--	setTranslation(self.translationklein2.node, unpack(newTrans)); 
	--end;
	-- Codice originale

	local doTranslate = self.translationMax or self.translationMin
	if self.translationklein3 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationklein3.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationklein3.maxTrans, self.translationklein3.minTrans, 3, self.translationklein3.transTime, dt, not self.translationMax); 
		setTranslation(self.translationklein3.node, unpack(newTrans)); 
	end;
end;

function Frontkanone:draw()
end;

function Frontkanone:onAttach(attacherVehicle)
end;

function Frontkanone:onDetach()
end;

function Frontkanone:onEnter()
end;

function Frontkanone:onLeave()
end;

function Frontkanone:onActivate()
end;

function Frontkanone:onDeactivate()
end;

function Frontkanone:onDeactivateSounds()
end;

function Frontkanone:addContactReports()
end;

function Frontkanone:removeContactReports()
end;

function Frontkanone:groundContactReport(objectId, otherObjectId, isStart, normalForce, tangentialForce)

end;

function Frontkanone:validateAttacherJoint(implement, jointDesc, dt)
end;